;==========================================================
; Map routines
;==========================================================



;==========================================================
; CreateSubMap
;==========================================================
; this creates the submap

CreateSubMap:
	ld a,(superMapY)
	ld h,0
	ld l,a
	add hl,hl ;*2
	add hl,hl ;*4
	ld d,h
	ld e,l
	add hl,hl ;*8
	add hl,hl ;*16
	add hl,de ;*20
	add hl,hl ;*40
	add hl,hl ;*80
	add hl,hl ;*160
	add hl,hl ;*320
	;add hl,hl ;*640

	ex de,hl
	ld a,(superMapX)
	ld l,a

	add hl,hl ;*2
	ld b,h
	ld c,l
	add hl,hl ;*4
	add hl,hl ;*8
	add hl,bc ;*10
	;add hl,hl ;*20

	add hl,de
	add hl,hl	;dw
	ld de,map0
	add hl,de

	ld de,submap
	ld b,8
mapSuper_yloop:
	push bc
	ld a,10
mapSuper_xloop:
	ld b,(hl)
	inc hl
	push hl
	ld h,(hl)
	ld l,b
	add hl,hl
	add hl,hl
	add hl,hl ;*8

	ld bc,convert
	add hl,bc
	ldi
	ldi
	ldi
	ldi
	push de
	ex de,hl
	ld bc,18*2 ;dw
	add hl,bc
	ex de,hl
	ldi
	ldi
	ldi
	ldi
	pop de
	pop hl
	inc hl

	dec a
	jr nz,mapSuper_xloop
	ex de,hl
	ld bc,20*2
	add hl,bc
	ex de,hl
	ld c,60
	add hl,bc
	pop bc
	djnz mapSuper_yloop
	ret





;***********************************************************************















DrawView:
	call LDhlView
	ld a,(scroll_y)
	neg
	ld c,a
	ld a,(scroll_x)
	neg
	ld b,a
	ld a,9    ;9 rows
UpdateRow:
	push af
	ld a,11   ;11 columns
UpdateCol:
	push af

	call PutSpriteHL

	inc hl
	ld a,b
	add a,8
	ld b,a
	pop af
	dec a
	jr nz,UpdateCol

	;ld a,(scroll_x)
	;neg
	;ld b,a
	ld a,b
	sub 88
	ld b,a

	ld a,c
	add a,8
	ld c,a

	ld de,9*2
	add hl,de
	pop af
	dec a
	jr nz,UpdateRow
	ret










UpdateAnimatedTiles:
	call LDhlView
	ld a,(scroll_y)
	neg
	ld c,a
	ld a,(scroll_x)
	neg
	ld b,a
	ld a,9    ;9 rows
CheckRow:
	push af
	ld a,11   ;11 columns
CheckCol:
	push af

	ld a,(hl)
	inc hl
	ld d,(hl)
	dec d
	jp p,NoAnimate
	ld e,4	;save speed and space
	sub 96
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
	sub 8
	jr z,AnimateTile
	sub 2
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
	sub e
	jr z,AnimateTile2
	dec a
	jr z,AnimateTile
	sub e
	jr z,AnimateTile2
	dec a
	jr z,AnimateTile
	sub e
	jr z,AnimateTile
NoAnimate:	
	inc hl
	ld a,b
	add a,8
	ld b,a
	pop af
	dec a
	jr nz,CheckCol

	;ld a,(scroll_x)
	;neg
	;ld b,a
	ld a,b
	sub 88
	ld b,a

	ld a,c
	add a,8
	ld c,a

	ld de,9*2
	add hl,de
	pop af
	dec a
	jr nz,CheckRow
	ret

AnimateTile2:
	ld a,(tileCounter)
	rra
	rra
	rra
	inc a
	jr animTile
AnimateTile:
	ld a,(tileCounter)
	rra
	rra
	rra
animTile:
	push hl
	push bc
	dec hl
	add a,(hl)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,tiles1
	add hl,de
	bcall(_PasteDirectlyOn)
	pop bc
	pop hl
	jr NoAnimate











;****************************Left Colission**********************************************

CheckLeftFull:
	call locateChar
CheckLeftCollision:
	ld a,(revedsprite+20)
	and 7
	ret nz
	ld a,(revedsprite+16)
	dec a
	jp m,loadCollision
	ld hl,(revedsprite+17)
	dec hl
notHitLeftEdge:
	ld (revedsprite),hl	;used to make Link skim walls
	ld a,(hl)
	or a
	jp nz,loadCollision
	dec hl ;dw
	ld a,(hl)
	cp 156	
	jp nc,loadCollision
	ld a,(revedsprite+19)
	and 7
	ret z
	ld e,20*2+1
	add hl,de
notHitLeftEdge2:
	ld a,(hl)
	or a
	jr nz,loadCollision
	dec hl
	ld a,(hl)
	cp 156
	jr nc,loadCollision
	or a
	ret 

	
;**************************Right Collision************************************************


CheckRightFull:
	call locateChar
CheckRightCollision:
	ld a,(revedsprite+20)
	and 7
	ret nz
	ld a,(revedsprite+16)
	cp 19*2
	jr z,loadCollision
	ld hl,(revedsprite+17)
	inc hl
	inc hl
	inc hl
	jr notHitLeftEdge


;*****************************Up Collision*******************************************************

CheckUpFull:
	call locateChar
CheckUpCollision:
	ld a,(revedsprite+19)
	ld c,a	;save
	and 3	;quarter of body can be off screen
	ret nz
	ld a,c
	and 7
	ld hl,(revedsprite+17)
	jr nz,keepBlockDown
	ld de,-40
	add hl,de
keepBlockDown:
	ld a,(mapYoff)
	sra c		;will stay negated
	sra c
	add a,c
	inc a
	jr z,loadCollision
	inc hl
notHitUpEdge:
	ld (revedsprite),hl	;used to make Link skim walls
	ld a,(hl)
	or a
	jr nz,loadCollision
	dec hl ;dw
	ld a,(hl)
	cp 156	
	jr nc,loadCollision
	ld a,(revedsprite+20)
	and 7
	ret z
	inc hl
	inc hl
	inc hl
	jr notHitLeftEdge2


;********************************Down Collision****************************************************

CheckDownFull:
	call locateChar
CheckDownCollision:
	ld a,(revedsprite+19)
	ld c,a	;save
	and 7
	ret nz
	ld hl,(revedsprite+17)
	ld de,20*2+1
	add hl,de
	ld a,(mapYoff)
	sra c		;will stay negated
	sra c
	sra c
	add a,c
	cp 14
	jr nz,notHitUpEdge
loadCollision:
	scf
	ret


;***************************All Collision***********************************************

locateChar:
	ld a,(mapYoff)
	ld b,a
	ld hl,linkY
	ld a,(scroll_y)
	add a,(hl)
	ld (revedsprite+19),a	;save
	sra a		;will stay negated
	sra a
	sra a
	add a,b
	inc a		;check only lower body
	ld b,a
	ld de,20*2
	ld hl,submap
	jr z,MapYTop
FindMapY:
	add hl,de
	djnz FindMapY
MapYTop:

	ld a,(mapXoff)
	ld c,a
	ld a,(linkX)
	add a,4	;center character
	ld e,a
	ld a,(scroll_x)
	add a,e
	ld (revedsprite+20),a	;save
	sra a		;will stay negated
	sra a
	sra a
	add a,c

	add a,a	;dw
	ld c,a
	add hl,bc
	ld (revedsprite+16),a	;so enemies won't nead to call this method
	ld (revedsprite+17),hl
	ret




checkWholePosition:
	call locateChar
	ld a,(revedsprite+19)
	and 7
	jr z,alignedY

	ld a,(hl)
	;compare special tiles
	ld a,(revedsprite+20)
	ld e,20*2
	and 7
	jr z,alignedX
	inc hl
	inc hl
	ld a,(hl)
	;compare special tiles
	dec e
	dec e
alignedX:
	add hl,de
alignedY:
	inc hl
	ld a,(hl)
	or a
	jr nz,noGrass
	dec hl
	ld a,(hl)
	sub 80
	jr z,setGrassFlag
	dec a
	jr z,setGrassFlag
	dec a
	jr z,setGrassFlag
	dec a
	jr z,setGrassFlag
	inc hl
noGrass:
	inc hl
	ld a,(revedsprite+20)
	and 7
	ret z
	inc hl
	ld a,(hl)
	or a
	ret nz
	dec hl
	ld a,(hl)
	sub 80
	jr z,setGrassFlag
	dec a
	jr z,setGrassFlag
	dec a
	jr z,setGrassFlag
	dec a
	ret nz

	

setGrassFlag:
	ld hl,grassFlag
	ld (hl),2
	ld a,(tileCounter)
	and 3
	ret nz
	dec (hl)
	ret









